Unit ZF16R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF10_p;

procedure ZF16R(F :Func_F1; A :Real; B :Real; EPS :Real; var ROOT :Real;
                ITMAX :Integer; var IERR :Integer);

implementation

procedure ZF16R(F :Func_F1; A :Real; B :Real; EPS :Real; var ROOT :Real;
                ITMAX :Integer; var IERR :Integer);
var
I :Integer;
R,RMID,DX,XMID :Real;
const
ZERO :Real = 0.0;
label
_10,_20,_30,_40,_60,_50;
begin
{      F()=0  (,)  }
IERR := 0;
RMID := F(B);
R := F(A);
if ( R*RMID < ZERO ) 
 then goto _10;
IERR := 66;
goto _60;
_10:
if ( R >= ZERO ) 
 then goto _20;
ROOT := A;
DX := B-A;
goto _30;
_20:
ROOT := B;
DX := A-B;
_30:
for I:=1 to ITMAX do
 begin
  _ZF16RR.elm1:= I;
  DX := DX/2;
  XMID := ROOT+DX;
  RMID := F(XMID);
  if ( RMID <= ZERO ) 
   then ROOT := XMID;
  if ( Abs(DX) < Abs(EPS) ) or ( RMID = ZERO ) 
   then goto _50;
_40:
 end;
IERR := 65;
_60:
UTZF10(IERR,16);
_50:
end;

end.
